<template>
    <div>
        <h1 id="heading" v-show="Object.keys(user).length">Hello, {{ user.displayName }}</h1>
        <div v-if="Object.keys(user).length">
            <button @click.prevent="signOut">Log out</button>
        </div>
        <div id="firebaseui-auth-container"></div>

        <posts></posts>

    </div>
</template>

<script>
    import firebase from '../app'

    export default {
        data(){
          return {
              ui:{},
              user:{}
          }
        },
        methods:{
            doAuth(){
                firebase.auth().onAuthStateChanged( user => {
                    if (user) {
                        this.user = user
                    } else {
                        this.ui.start('#firebaseui-auth-container', {
                            signInOptions: [
                                firebase.auth.EmailAuthProvider.PROVIDER_ID
                            ],
                            callbacks: {
                                signInSuccessWithAuthResult:  (authResult, redirectUrl) => {
                                    return false;
                                },
                            }
                        });
                    }
                });
            },
            signOut(){
                firebase.auth().signOut().then(function() {
                    window.location.reload()
                }).catch(function(error) {
                    // An error happened.
                });
            }
        },
        mounted(){
            this.ui = new firebaseui.auth.AuthUI(firebase.auth());
            this.doAuth()
        }
    }
</script>

<style scoped>

</style>